org.richfaces.component

## Class UIOrderingList

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - javax.faces.component.UIData
      - - org.ajax4jsf.component.UIDataAdaptor
        - - org.richfaces.component.UIOrderingBaseComponent
          - - org.richfaces.component.UIOrderingList

- All Implemented Interfaces:
    javax.faces.component.EditableValueHolder, javax.faces.component.NamingContainer, javax.faces.component.StateHolder, javax.faces.component.ValueHolder, org.ajax4jsf.component.AjaxChildrenEncoder, org.ajax4jsf.component.AjaxDataEncoder
  Direct Known Subclasses:
    HtmlOrderingList

      public abstract class UIOrderingList
      extends UIOrderingBaseComponent

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `UIOrderingList.SubmittedValue`
    `static class` | `UIOrderingList.ValueHolder`

    - ### Nested classes/interfaces inherited from class org.richfaces.component.UIOrderingBaseComponent

      `UIOrderingBaseComponent.DataAdder, UIOrderingBaseComponent.ItemState, UIOrderingBaseComponent.UpdateModelCommand`

    - ### Nested classes/interfaces inherited from class org.ajax4jsf.component.UIDataAdaptor

      `org.ajax4jsf.component.UIDataAdaptor.ComponentVisitor, org.ajax4jsf.component.UIDataAdaptor.IndexedEvent`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected UIOrderingBaseComponent.UpdateModelCommand` | `updateActiveItemCommand`
    `protected UIOrderingBaseComponent.UpdateModelCommand` | `updateSelectionCommand`
    `protected UIOrderingBaseComponent.UpdateModelCommand` | `updateValueCommand`

    - ### Fields inherited from class org.richfaces.component.UIOrderingBaseComponent

      `isColumn`

    - ### Fields inherited from class org.ajax4jsf.component.UIDataAdaptor

      `COMPONENT_STATE_ATTRIBUTE, decodeVisitor, EMPTY_MODEL, updateVisitor, validateVisitor`

    - ### Fields inherited from class javax.faces.component.UIData

      `COMPONENT_FAMILY, COMPONENT_TYPE`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `bindings`

    - ### Fields inherited from interface javax.faces.component.NamingContainer

      `SEPARATOR_CHAR`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `UIOrderingList()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addValueChangeListener(javax.faces.event.ValueChangeListener listener)`
    `void` | `broadcast(javax.faces.event.FacesEvent event)` In addition to to the default `UIComponent.broadcast(javax.faces.event.FacesEvent)` processing, pass the `ValueChangeEvent` being broadcast to the method referenced by `valueChangeListener` (if any).
    `protected org.ajax4jsf.model.ExtendedDataModel` | `createDataModel()`
    `java.lang.Object` | `getActiveItem()`
    `abstract java.lang.String` | `getControlsType()`
    `abstract javax.faces.convert.Converter` | `getConverter()`
    `UIOrderingBaseComponent.ItemState` | `getItemState()`
    `java.lang.Object` | `getLocalValue()`
    `java.util.Set` | `getSelection()`
    `java.lang.Object` | `getSubmittedValue()`
    `java.lang.Object` | `getValue()`
    `abstract javax.faces.el.MethodBinding` | `getValueChangeListener()`
    `javax.faces.event.ValueChangeListener[]` | `getValueChangeListeners()`
    `abstract boolean` | `isImmediate()`
    `abstract boolean` | `isRequired()`
    `abstract boolean` | `isValid()`
    `void` | `processDecodes(javax.faces.context.FacesContext context)` Specialized decode behavior on top of that provided by the superclass.
    `protected void` | `processDecodes(javax.faces.context.FacesContext faces, java.lang.Object argument)`
    `void` | `processUpdates(javax.faces.context.FacesContext context)` In addition to the standard `processUpdates` behavior inherited from `UIComponentBase`, calls `updateModel()`.
    `void` | `processValidators(javax.faces.context.FacesContext context)` In addition to the standard `processValidators` behavior inherited from `UIComponentBase`, calls `validate()` if the `immediate` property is false (which is the default); if the component is invalid afterwards, calls `FacesContext.renderResponse()`.
    `void` | `removeValueChangeListener(javax.faces.event.ValueChangeListener listener)`
    `protected void` | `resetDataModel()`
    `protected void` | `restoreIterationState(java.lang.Object object)`
    `void` | `restoreState(javax.faces.context.FacesContext faces, java.lang.Object object)`
    `protected java.lang.Object` | `saveIterationState()`
    `java.lang.Object` | `saveState(javax.faces.context.FacesContext faces)`
    `void` | `setActiveItem(java.lang.Object activeItem)`
    `abstract void` | `setControlsType(java.lang.String type)`
    `abstract void` | `setConverter(javax.faces.convert.Converter converter)`
    `abstract void` | `setImmediate(boolean immediate)`
    `abstract void` | `setRequired(boolean required)`
    `void` | `setSelection(java.util.Set selection)`
    `void` | `setSubmittedString(java.util.Map submittedString, java.util.Set selection, java.lang.Object activeItem)`
    `void` | `setSubmittedValue(java.lang.Object object)`
    `abstract void` | `setValid(boolean valid)`
    `void` | `setValue(java.lang.Object value)`
    `abstract void` | `setValueChangeListener(javax.faces.el.MethodBinding valueChangeMethod)`
    `void` | `updateModel(javax.faces.context.FacesContext context)` Perform the following algorithm to update the model dataMap associated with this `UIInput`, if any, as appropriate.
    `void` | `validate(javax.faces.context.FacesContext context)` Perform the following algorithm to validate the local value of this `UIInput`.
    `protected void` | `validateValue(javax.faces.context.FacesContext context, java.lang.Object newValue)`

    - ### Methods inherited from class org.richfaces.component.UIOrderingBaseComponent

      `addConversionErrorMessage, addValidator, columns, compareValues, createComponentState, createContainer, createDataModel, dataChildren, decode, executeValidate, fixedChildren, getConverterForValue, getRequiredMessage, getValidator, getValidators, isEmpty, isFastOrderControlsVisible, isLocalValueSet, isOrderControlsVisible, isSuitableValue, removeValidator, requiredInvalidate, setFastOrderControlsVisible, setLocalValueSet, setOrderControlsVisible, setRequiredMessage, setValidator, updateModel`

    - ### Methods inherited from class org.ajax4jsf.component.UIDataAdaptor

      `addAjaxKeyEvent, addRequestKey, beforeRenderResponse, broadcastLocal, captureOrigValue, captureOrigValue, clearRequestKeysSet, containsRequestKey, encodeAjaxChild, encodeBegin, extractKeySegment, getAjaxKeys, getAllAjaxKeys, getBaseClientId, getChildrenRenderer, getChildState, getClientId, getComponentState, getEncodedIds, getExtendedDataModel, getRowCount, getRowData, getRowIndex, getRowKey, getRowKeyConverter, getRowKeyVar, getStateVar, invocableChildren, invokeOnComponent, isRowAvailable, iterate, keepSaved, processUpdates, processValidators, queueEvent, removeRequestKey, resetComponent, restoreChildState, restoreOrigValue, restoreOrigValue, saveChildState, setAjaxKeys, setComponentState, setExtendedDataModel, setId, setParent, setRowIndex, setRowKey, setRowKey, setRowKeyConverter, setRowKeyVar, setStateVar, setupVariable, walk`

    - ### Methods inherited from class javax.faces.component.UIData

      `getDataModel, getFamily, getFirst, getFooter, getHeader, getRows, getVar, setDataModel, setFirst, setFooter, setHeader, setRows, setValueBinding, setValueExpression, setVar`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addFacesListener, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, isRendered, isTransient, processRestoreState, processSaveState, removeFacesListener, restoreAttachedState, saveAttachedState, setRendered, setRendererType, setTransient`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getContainerClientId, getValueExpression`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### updateActiveItemCommand

          protected final UIOrderingBaseComponent.UpdateModelCommand updateActiveItemCommand

    - #### updateSelectionCommand

          protected final UIOrderingBaseComponent.UpdateModelCommand updateSelectionCommand

    - #### updateValueCommand

          protected final UIOrderingBaseComponent.UpdateModelCommand updateValueCommand

  - ### Constructor Detail

    - #### UIOrderingList

          public UIOrderingList()

  - ### Method Detail

    - #### processDecodes

          protected void processDecodes(javax.faces.context.FacesContext faces,
                            java.lang.Object argument)

      Overrides:
        `processDecodes` in class `org.ajax4jsf.component.UIDataAdaptor`

    - #### createDataModel

          protected org.ajax4jsf.model.ExtendedDataModel createDataModel()

      Specified by:
        `createDataModel` in class `org.ajax4jsf.component.UIDataAdaptor`

    - #### addValueChangeListener

          public void addValueChangeListener(javax.faces.event.ValueChangeListener listener)

    - #### getValueChangeListener

          public abstract javax.faces.el.MethodBinding getValueChangeListener()

    - #### getValueChangeListeners

          public javax.faces.event.ValueChangeListener[] getValueChangeListeners()

    - #### isImmediate

          public abstract boolean isImmediate()

    - #### isRequired

          public abstract boolean isRequired()

    - #### isValid

          public abstract boolean isValid()

    - #### removeValueChangeListener

          public void removeValueChangeListener(javax.faces.event.ValueChangeListener listener)

    - #### setSubmittedString

          public void setSubmittedString(java.util.Map submittedString,
                                java.util.Set selection,
                                java.lang.Object activeItem)

    - #### getSubmittedValue

          public java.lang.Object getSubmittedValue()

    - #### setSubmittedValue

          public void setSubmittedValue(java.lang.Object object)

    - #### saveIterationState

          protected java.lang.Object saveIterationState()

    - #### restoreIterationState

          protected void restoreIterationState(java.lang.Object object)

    - #### setImmediate

          public abstract void setImmediate(boolean immediate)

    - #### setRequired

          public abstract void setRequired(boolean required)

    - #### setValid

          public abstract void setValid(boolean valid)

    - #### setValueChangeListener

          public abstract void setValueChangeListener(javax.faces.el.MethodBinding valueChangeMethod)

    - #### getConverter

          public abstract javax.faces.convert.Converter getConverter()

    - #### setConverter

          public abstract void setConverter(javax.faces.convert.Converter converter)

    - #### processDecodes

          public void processDecodes(javax.faces.context.FacesContext context)

      Specialized decode behavior on top of that provided by the superclass. In addition to the standard `processDecodes` behavior inherited from `UIComponentBase`, calls `validate()` if the the `immediate` property is true; if the component is invalid afterwards or a `RuntimeException` is thrown, calls `FacesContext.renderResponse()`.

    - #### processValidators

          public void processValidators(javax.faces.context.FacesContext context)

      In addition to the standard `processValidators` behavior inherited from `UIComponentBase`, calls `validate()` if the `immediate` property is false (which is the default); if the component is invalid afterwards, calls `FacesContext.renderResponse()`. If a `RuntimeException` is thrown during validation processing, calls `FacesContext.renderResponse()` and re-throw the exception.

    - #### processUpdates

          public void processUpdates(javax.faces.context.FacesContext context)

      In addition to the standard `processUpdates` behavior inherited from `UIComponentBase`, calls `updateModel()`. If the component is invalid afterwards, calls `FacesContext.renderResponse()`. If a `RuntimeException` is thrown during update processing, calls `FacesContext.renderResponse()` and re-throw the exception.

    - #### broadcast

          public void broadcast(javax.faces.event.FacesEvent event)
                         throws javax.faces.event.AbortProcessingException

      In addition to to the default `UIComponent.broadcast(javax.faces.event.FacesEvent)` processing, pass the `ValueChangeEvent` being broadcast to the method referenced by `valueChangeListener` (if any).

      Overrides:
        `broadcast` in class `org.ajax4jsf.component.UIDataAdaptor`
      Parameters:
        `event` - `FacesEvent` to be broadcast
      Throws:
        `javax.faces.event.AbortProcessingException` - Signal the JavaServer Faces implementation that no further processing on the current event should be performed
        `java.lang.IllegalArgumentException` - if the implementation class of this `FacesEvent` is not supported by this component
        `java.lang.NullPointerException` - if `event` is `null`

    - #### updateModel

          public void updateModel(javax.faces.context.FacesContext context)

      Perform the following algorithm to update the model dataMap associated with this `UIInput`, if any, as appropriate.

      - If the `valid` property of this component is `false`, take no further action.
      - If the `localValueSet` property of this component is `false`, take no further action.
      - If no `ValueBinding` for `value` exists, take no further action.
      - Call `setValue()` method of the `ValueBinding` to update the value that the `ValueBinding` points at.
      - If the `setValue()` method returns successfully:
        - Clear the local value of this `UIInput`.
        - Set the `localValueSet` property of this `UIInput` to false.
      - If the `setValue()` method call fails:
        - Enqueue an error message by calling `addMessage()` on the specified `FacesContext` instance.
        - Set the `valid` property of this `UIInput` to `false`.
      Specified by:
        `updateModel` in class `UIOrderingBaseComponent`
      Parameters:
        `context` - `FacesContext` for the request we are processing
      Throws:
        `java.lang.NullPointerException` - if `context` is `null`

    - #### validateValue

          protected void validateValue(javax.faces.context.FacesContext context,
                           java.lang.Object newValue)

      Overrides:
        `validateValue` in class `UIOrderingBaseComponent`

    - #### validate

          public void validate(javax.faces.context.FacesContext context)

      Perform the following algorithm to validate the local value of this `UIInput`.

      - Retrieve the submitted value with `getSubmittedValue()`. If this returns null, exit without further processing. (This indicates that no value was submitted for this component.)
      - Convert the submitted value into a "local value" of the appropriate dataMap type by calling `#getConvertedValue`.
      - Validate the property by calling `validateValue(javax.faces.context.FacesContext, java.lang.Object)`.
      - If the `valid` property of this component is still `true`, retrieve the previous value of the component (with `getValue()`), store the new local value using `setValue()`, and reset the submitted value to null. If the local value is different from the previous value of this component, fire a `ValueChangeEvent` to be broadcast to all interested listeners.

      Application components implementing `UIInput` that wish to perform validation with logic embedded in the component should perform their own correctness checks, and then call the `super.validate()` method to perform the standard processing described above.

      Specified by:
        `validate` in class `UIOrderingBaseComponent`
      Parameters:
        `context` - The `FacesContext` for the current request
      Throws:
        `java.lang.NullPointerException` - if `context` is null

    - #### resetDataModel

          protected void resetDataModel()

      Overrides:
        `resetDataModel` in class `org.ajax4jsf.component.UIDataAdaptor`

    - #### getItemState

          public UIOrderingBaseComponent.ItemState getItemState()

      Specified by:
        `getItemState` in class `UIOrderingBaseComponent`

    - #### getControlsType

          public abstract java.lang.String getControlsType()

    - #### setControlsType

          public abstract void setControlsType(java.lang.String type)

    - #### getSelection

          public java.util.Set getSelection()

    - #### setSelection

          public void setSelection(java.util.Set selection)

    - #### getActiveItem

          public java.lang.Object getActiveItem()

    - #### setActiveItem

          public void setActiveItem(java.lang.Object activeItem)

    - #### setValue

          public void setValue(java.lang.Object value)

      Specified by:
        `setValue` in interface `javax.faces.component.ValueHolder`
      Overrides:
        `setValue` in class `org.ajax4jsf.component.UIDataAdaptor`

    - #### getLocalValue

          public java.lang.Object getLocalValue()

    - #### getValue

          public java.lang.Object getValue()

      Specified by:
        `getValue` in interface `javax.faces.component.ValueHolder`
      Overrides:
        `getValue` in class `org.ajax4jsf.component.UIDataAdaptor`

    - #### saveState

          public java.lang.Object saveState(javax.faces.context.FacesContext faces)

      Specified by:
        `saveState` in interface `javax.faces.component.StateHolder`
      Overrides:
        `saveState` in class `UIOrderingBaseComponent`

    - #### restoreState

          public void restoreState(javax.faces.context.FacesContext faces,
                          java.lang.Object object)

      Specified by:
        `restoreState` in interface `javax.faces.component.StateHolder`
      Overrides:
        `restoreState` in class `UIOrderingBaseComponent`

Copyright © 2013. All Rights Reserved.